import { createDictionaryHandler } from './util/dictionary-handler';
import { compose } from './util/compose';
import { parseContentLines, serializeContentLines } from './schema/parser';
import { exdateDefinition } from './content-lines/exdate';
import { rruleDefinition } from './content-lines/rrule';
var contentLinesHandler = createDictionaryHandler([
    exdateDefinition,
    rruleDefinition
]);
export var parse = compose(contentLinesHandler.parse, parseContentLines);
export var serialize = compose(serializeContentLines, contentLinesHandler.serialize);
export { Days } from './schema/tokens';
export { Frequencies } from './recurrences/definitions/freq';
