"use strict";
var parser_1 = require('../../schema/parser');
var compose_1 = require('../../util/compose');
(function (Frequencies) {
    Frequencies[Frequencies["Yearly"] = 0] = "Yearly";
    Frequencies[Frequencies["Monthly"] = 1] = "Monthly";
    Frequencies[Frequencies["Weekly"] = 2] = "Weekly";
    Frequencies[Frequencies["Daily"] = 3] = "Daily";
    Frequencies[Frequencies["Hourly"] = 4] = "Hourly";
    Frequencies[Frequencies["Minutely"] = 5] = "Minutely";
    Frequencies[Frequencies["Secondly"] = 6] = "Secondly";
})(exports.Frequencies || (exports.Frequencies = {}));
var Frequencies = exports.Frequencies;
;
function parseFrequencies(input) {
    switch (input) {
        case 'YEARLY': return Frequencies.Yearly;
        case 'MONTHLY': return Frequencies.Monthly;
        case 'WEEKLY': return Frequencies.Weekly;
        case 'DAILY': return Frequencies.Daily;
        case 'HOURLY': return Frequencies.Hourly;
        case 'MINUTELY': return Frequencies.Minutely;
        case 'SECONDLY': return Frequencies.Secondly;
        default:
            throw new Error("Encountered unexpected frequency value: '" + input + "'");
    }
}
function serializeFrequencies(input) {
    return Frequencies[input].toUpperCase();
}
exports.freqDefinition = {
    parsedKey: 'frequency',
    parse: compose_1.compose(parseFrequencies, parser_1.parseValue),
    serializedKey: 'FREQ',
    serialize: compose_1.compose(parser_1.serializeValue, serializeFrequencies)
};
